import './bootstrap.js'; // Stimulus

import './vendor/bootstrap/dist/css/bootstrap.min.css'; // Bootstrap
import './vendor/leaflet/dist/leaflet.min.css'; // Leaflet
import './styles/app.css'; // Nos personnalisations

import { Tooltip } from './vendor/bootstrap/bootstrap.index.js';
const tooltipTriggerList = document.querySelectorAll('[data-bs-toggle="tooltip"]')
const tooltipList = [...tooltipTriggerList].map(tooltipTriggerEl => new Tooltip(tooltipTriggerEl))

// Implémente une sécurité basique pour confirmer le clic sur tous les boutons
// qui emènent sur une adresse web susceptible de supprimer quelque-chose…
document.addEventListener('click', function (event) {
    if (event.target.matches('a[href*="remove"]')) {
        if (!confirm(event.target.innerText + ' ?')) {
            event.preventDefault();
            return false;
        }
    }
});
